// Copyright 2019 getensh.com. All rights reserved.
// Use of this source code is governed by getensh.com.

package task

import (
	"adm-dws/model"
	"gorm.io/gorm"
	"strconv"
)

func calcPlateType(longStr,approvedNumberStr,grossMassStr string) string {
	long,_ := strconv.Atoi(longStr)
	approvedNumber,_ := strconv.Atoi(approvedNumberStr)
	grossMass,_ := strconv.Atoi(grossMassStr)

	if  long >= 6000 || approvedNumber >= 20 || grossMass >= 4500{
		return "01"
	}

	if (long != 0) && (approvedNumber != 0 || grossMass != 0) {
		if (long < 6000 && approvedNumber > 9){
			return  "01"
		}else{
			return "02"
		}
	}

	return ""
}

func CalcPlateTypeByDws5(db *gorm.DB,vin string) string {
	dws5 := &model.Dws5{}
	err := dws5.Query(db, map[string]interface{}{"vin": vin})
	if err != nil{
		return ""
	}

	return calcPlateType(dws5.Long,dws5.ApprovedNumber,dws5.GrossMass)
}

func CalcPlateTypeByDws11(db *gorm.DB,vin string) string{
	if len(vin) >= 8{
		dws11 := &model.Dws11{}
		dws11.VinRule = vin[0:8]
		dws11List := []model.Dws11{}
		err := dws11.QueryAll(db,map[string]interface{}{"vin_rule":dws11.VinRule},&dws11List)
		if err != nil{
			return ""
		}
		for _,v := range dws11List{
			dws12 := &model.Dws12{}
			err = dws12.Query(db,map[string]interface{}{"model_no":v.ModelNo})
			if err == nil{
				return dws12.PlateType
			}
		}
	}

	return ""
}

func CalcPlateType(db *gorm.DB,vin string) string{
	/*plateType := CalcPlateTypeByDws5(db,vin)
	if plateType != ""{
		return plateType
	}*/

	return CalcPlateTypeByDws11(db,vin)
}

func SupplementDws1PlateType(db *gorm.DB,vin ,longStr,approvedNumberStr,grossMassStr string) (*model.Dws4,error){
	where := map[string]interface{}{"vin": vin}
	dws4 := &model.Dws4{}
	err := dws4.Query(db, where)
	if err != nil {
		return nil,err
	}

	dws4.PlateType=calcPlateType(longStr,approvedNumberStr,grossMassStr)
	if dws4.PlateType == ""{
		return nil,nil
	}
	dws4.Delete(db,nil)
	return dws4,nil
}
